/*
	Functions used in control program

	post_select:
		Select next post to which MIRS approah 
	irs_code_get: 
		Get IRS code
	uss_get:
		Get USS data (one shot task)
	correct_direction1: this is renewed one
		Correct direction before approach the target post.
	correct_direction2: this is renewed one
		Correct direction after approach the target post.
	move_center:
		Move to center postion after post_get mode
	lqr_rotate:
		Macro of rotaion in LQR mode;
	lqr_straght:
		Macro of straight movement in LQR mode;
	lqr_circle:
		Macro of going around a post in LQR mode;
*/
#include "mirs_head.h"
#include "define.h"

#define USS_MAX4 1000

int post_select(int center_count){

	int dis_min;
	int i;
	int next_post_num=-1;
	int next_post_code;

	dis_min=2000; 
	next_post_code=post.got_code+1;

	printf("post.got_code=%d post_number=%d\n",post.got_code,post.number);

	for(i=0;i<post.number;i++){
		printf("i=%d dis=%d ang=%d code=%d got=%d\n",i,post.dis[i],post.ang[i],post.code[i],post.got_post[i]);
	}

	printf("center_count=%d  next_post_code=%d dis_min=%d\n",center_count,next_post_code,dis_min);

	if(center_count==1){
		for(i=0;i<post.number;i++){
			printf("i=%d post.dis=%d dis_min=%d\n",i,post.dis[i],dis_min); 
			if(post.dis[i]<dis_min){
				dis_min=post.dis[i];
				next_post_num=i;
			}
		}
		return next_post_num;
	}

	if(center_count>1){
		for(i=0;i<post.number;i++){
			if(post.code[i]==next_post_code){
				return i;
			}
		}
		for(i=0;i<post.number;i++){
			if(post.code[i]==0 && post.dis[i]<dis_min){
				dis_min=post.dis[i];
				next_post_num=i;
			}
		}
		return next_post_num;
	}

	return -1;
}

int irs_code_get(int dumy){

	int irs_select;
	int irs_get_code=0;
	char code_char='0';
	irs_select = dumy;

	fd6=open("/dev/irs_code",O_RDWR);
	write(fd6,&irs_select,sizeof(int));
        usleep(10000);
	read(fd6,&code_char,sizeof(char));
	close(fd6);
	fd6=open("/dev/irs_code",O_RDWR);
        usleep(100000);
	read(fd6,&code_char,sizeof(char));

	if(code_char=='1') {irs_get_code=1; goto NEXT;}
	if(code_char=='2') {irs_get_code=2; goto NEXT;}
	if(code_char=='3') {irs_get_code=3; goto NEXT;}
	if(code_char=='4') {irs_get_code=4; goto NEXT;}
	if(code_char=='5') {irs_get_code=5; goto NEXT;}
	if(code_char=='6') {irs_get_code=6; goto NEXT;}
  NEXT:
        usleep(100000);
	close(fd6);

	printf("irs_get_code=%d\n",irs_get_code);

	return irs_get_code;
}

int uss_get(int uss_no){

        uss_msg.command=1; /* 1 Shot Task */
        uss_msg.number = uss_no;
        write(ctl, &uss_msg, sizeof(uss_msg));

        usleep(30000);
        printf("uss_data %d\n",uss_data);
        return uss_data;
}

int correct_direction1(int target_post){
	FILE *fp;
	int uss1,uss2,uss3;
	int maxdif;
	int r_value = 0;
	int r_count = 0;
	fp=fopen("txt/direction.xls","w");
	fprintf(fp,"correct_direction1 function start\n");

	maxdif=10;
	cor_ang=0;
	uss1=uss_get(2);
	uss2=uss_get(1);
	fprintf(fp,"uss1\tuss2\n");
	while(1){
	NSS1:
		//renew the uss data
		uss1=uss_get(2);
		usleep(60000);
		uss2=uss_get(1);
		usleep(60000);
		uss12=(uss1+uss2)/2;
		fprintf(fp,"%d\t%d\n",uss1,uss2);
		if(cor_ang>70){
			cor_ang+=lqr_rotate(-100,1000);
		}
		if(cor_ang<-70){
			cor_ang+=lqr_rotate(100,1000);
		}
		//uss1 == 9999 || uss2 == 9999 is included in the if-block
		if(uss1>USS_MAX4 && uss2>USS_MAX4){
			printf("USS ERROR!\n");
			r_count++;
			//when if-block is called, the post does not exist.
			if(r_count == 30){
				printf("post does not exist.\n");
				r_value = -1;
				break;
			}else{//uss_error
				printf("uss errer_count = %d\n",r_count);
				goto NSS1;
			}
		}
		if( uss1>USS_MAX4 ){
			r_count = 0; /*clear uss_error count*/
			cor_ang+=lqr_rotate(-20,1000);
//			m[2]+=lqr_rotate(-20,1000); 
			goto NSS1;
		}
		if( uss2>USS_MAX4 ){
			r_count = 0;
			cor_ang+=lqr_rotate(20,1000); 
//			m[2]+=lqr_rotate(20,1000);
			goto NSS1;
		}

		if(abs(uss1-uss2-USS12_DIFF)<=maxdif){
			r_value = 1;
			if(uss1>210 && uss2>210){ 
				break;
			}
		}
		if(uss1-USS12_DIFF > uss2) {
			r_count = 0;
			cor_ang+=lqr_rotate(-13,1000); 
//			m[2]+=lqr_rotate(-13,1000);
			goto NSS1;
		} 
		if(uss2+USS12_DIFF > uss1) {
			r_count = 0;
			cor_ang+=lqr_rotate(15,1000);  
//			m[2]+=lqr_rotate(15,1000);
			goto NSS1;
		}
//		if(cor_ang>45){
//			cor_ang+=lqr_rotate(-45,1000);
//		}
//		if(cor_ang<-45){
//			cor_ang+=lqr_rotate(45,1000);
//		}
	}
	uss3==(uss1+uss2)/2;
	printf("uss1=%d uss2=%d\n",uss1,uss2);
	printf("correct_direction1 func end.\n");
	// If you wish to redefine post angle and distance,
	// remove comment-out in next line. 
	//post.ang[target_post]+=angle;
	//post.dis[target_post]=(uss1+uss2)/2 - uss_dis[is]+USS_CORRECT+MCENTER_USS3_DIS+post_diameter/2;
	fclose(fp);
	return uss3;
}

int correct_direction2(int target_post){
	int uss1,uss2;

	printf("correct_direction2 function start\n");
	while(1){
		NSS1:	
		uss1=uss_get(1);
		usleep(20000);
		uss2=uss_get(2);
		usleep(20000);
		if( uss1 == 9999 || uss2 == 9999){
			printf("USS ERROR\n");
			goto NSS1;
		}

		if(abs(uss1-uss2+USS12_DIFF)<=10){
			if(uss1>210 && uss2>210){
			 	break;
			}
		}
		if(uss1+USS12_DIFF > uss2){
			//lqr_rotate(-12,1000); 
			lqr_rotate(-12,300); 
		} 
		else {
			//lqr_rotate(16,1000);  
			lqr_rotate(16,300);  
		}
		usleep(100000);
	}
	printf("uss1=%d uss2=%d\n",uss1,uss2);
	printf("correct_direction2 func end.\n");
	return 0; 
} 

int move_center(int target_post){

	int move_time;
	int rotate_time;
	int angle;
	int distance;

	lqr_rotate(90,1800);
	
	//correct direction2 
	correct_direction2(target_post);

	usleep(500000);
	printf("return_dist=%d\n",return_dist);
	distance=-return_dist;
	move_time=distance*4;
	lqr_straight(distance,move_time);
	usleep(500000);

	if(post.ang[target_post]<180){
		//angle= 180-post.ang[target_post];
		angle= -post.ang[target_post];
	}else{
		//angle= -(post.ang[target_post]-180);
		angle= 360-post.ang[target_post];
	}
	rotate_time=angle*20;
	lqr_rotate(angle,rotate_time);
	usleep(1000000);
	
	return 0;
}

int lqr_rotate(int ang,int time){

	int angle=0;
	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_rotate(ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	angle=180*diameter*count.left_sum/(dist_ct*cpr*gear);
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return angle;
}

int lqr_straight(int dis,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_straight(dis,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}

int lqr_circle(int radious,int ang,int time){

	pwm_enco_start(10);
	usleep(40000);
	pwm_lqr_circle(radious,ang,abs(time));
	usleep(40000);
        count.br=0;
        while(1){
                if(count.br==1) break;
                usleep(20000);
        }
	pwm_both_data(0,0);
	usleep(40000);
	pwm_enco_stop();
	return 0;
}
