#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

int main()
{
	/*
	center_count : count of center postion
	target_post  : post number selected by post_select()
		"post number" means seaquencial number of posts found in post_search()
	target_code  : IRS code of the post to get now
		This variable is defined as gloabl varialble.
	*/
	int center_count=0;
	int center_corr_count=0;
	int target_post;
	int ret;
	int search_retry, search_result=-1;
	int i;
	FILE *fp;

	fp=fopen("post_data.txt","w");
	post.got_number=0;

	printf("Initialize\n");
	ret=initialize();

	printf("Move to center\n");
	//lqr_straight(1450,6000);
	lqr_straight(1000,3000);

/*
	post.ang[0]=120;
	post.ang[1]=270;
	post.dis[0]=300;
	post.dis[1]=500;
	post.number=2;
*/

POST_SH:

	printf("POST_NUM= %d  post.got_number= %d\n",POST_NUM, post.got_number);
	if(post.got_number==POST_NUM) goto END;

	center_count++;
	center_corr_count++;


        usleep(300000);

        pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);


	printf("Post search 1st Try\n");

	if(center_count==1){
		printf("Searched post number =%d\n",post.number);
		while(post.number!=POST_NUM){
        		usleep(300000);
			post_search(center_count);
			printf("Searched post number =%d\n",post.number);
			if(post.number >= POST_NUM){
				post_check(center_count);
				printf("Searched post number after post_check=%d\n",post.number);
			}
		}
	}
	for(i=0;i<post.number;i++){
			printf("post.ang[%d]=%d  post.dis[%d]=%d\n",i,post.ang[i],i,post.dis[i]);
	}

	//exit(0);

	if(center_corr_count>2){
		printf("Searched post number =%d\n",post_tmp.number);
		search_retry=0;
		search_result=0;
		while(post_tmp.number!=POST_NUM){
        		usleep(300000);
			if(search_retry>=2){
				search_result=-1;
				break;
			}
			post_search(center_count);
			printf("Searched post number =%d\n",post_tmp.number);
			if(post.number >= POST_NUM){
				post_check(center_count);
			}
			search_retry++;
		}
	}
        usleep(300000);

	if(center_corr_count>2 && search_result==0) {
		center_corr_count=0; 
		printf("Move to correct center position\n");
		//printf("dis1=%d dis2=%d ang1=%d ang2=%d\n",post.dis[0],post.dis[1],post.ang[0],post.ang[1]);
		//printf("dis1_=%d dis2_=%d ang1_=%d ang2_=%d\n",post_tmp.dis[0],post_tmp.dis[1],post_tmp.ang[0],post_tmp.ang[1]);
		correct_center();
	}

	pthread_cancel(uss_task);

        pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);

        usleep(300000);
	target_post = post_select(center_count);
	printf("Next post is %d\n",target_post);

	printf("Approach target_post\n");
	post_approach(target_post);


	target_code=post.got_code+1;


	printf("Post get start\n");
	post_get(target_post);

	//exit(0);

	printf("Move center\n");
	move_center(target_post);

	pthread_cancel(uss_task2);

	//exit(0);

	goto POST_SH;

END:

	usleep(300000);
	pwm_both_data(0,0);
	usleep(400000);
	pwm_enco_stop();
	usleep(400000);
	printf("All posts have been got\n");
	printf("Original Post postion\n");
	fprintf(fp,"Original Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post.ang[i],post.dis[i]);
	}
	printf("Tempral Post postion\n");
	for(i=0;i<post.number;i++){
		printf("Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
		fprintf(fp,"Post No[%d]  Angle=%d  Distance=%d\n",i,post_tmp.ang[i],post_tmp.dis[i]);
	}

	// close all device file 
        close(fd0);
        close(fd1);
        close(fd2);
        close(fd3);
        //close(fd4);
        close(fd5);
        //close(fd6);
        //close(fd7);
        close(ctl);
        fclose(fp);
        return 0;
}
