#include "mirs_head.h"
#include "define.h"
#define MPOST_DIAMETER 200
#define MMIRS_DIAMETER 340


/*print functions*/
void map_print(void);   /*map print*/
void map_print2(void);   /*map print*/
void map_fprint(int mode);
/*0: 360_search*/
/*1: 1st_approach*/
/*2: 2nd_approach*/
/*3: 3rd_approach*/
/*4: 4th_approach*/
/*5: theory*/
/*6: analyze*/
/*7: extra*/
/*8: test*/

/*make map funtions*/
void map_clean(void);   /*map clean*/
void map_set(void);     /*map set*/
void map_mirs(void);	/*mirs map set*/
void map_firstset(int found);
int map_around(int x, int y,int nume,int mode);

/*move with map funcitons*/
int map_absmove_ang(int x,int y);
int map_absmove_dis(int x,int y);
int map_move(int x,int y,int z);

/*extra functions*/
int half_adjust(double num);

/*to find unknown post*/
void map_analyze(int n);
void map_theory(void);
/*if mirs cannot find out all posts, this function search unfind post.*/
/*and this func can be call center position.*/

void map_print(void){
	int i,j;
	printf("*= ------------------------- virtual map system --------------------------- =*\n");
	printf("  +------------------------------+\n");
	for(i=15;i>=1;i--){
		for(j=1;j<=15;j++){
			if(j==1)printf("%2d|",i);
			if(num[j][i]!=1){
				printf("%2d",num[j][i]);
			}else{
				printf("  ");
			}
		}
		printf("|");
		if(i==15){ printf("      This virtual map presented by MIRS0701");}
		if(i==14){ printf("            made by Ozawa Taku & Ozawa Ryuji");}
		if(i==13){ printf(" =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i==12){ printf(" *Field : 3200 x 3200 *ONE BLOCK : 227 x 227");}
		if(i==11){ printf("            *MIRS: 3 *POST: 1X *POST NEAR: 0");}
		if(i==10){ printf("           *00: unknown post *X: Post number");}
		if(i== 9){ printf(" =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i== 8){ printf("  **                                        ");}
		if(i== 7){ printf("  **     ***********************************");}
		if(i== 6){ printf("  **    ***                                 ");}
		if(i== 5){ printf("  **   ***      *       *     *     ******* ");}
		if(i== 4){ printf("  **  ***       *      **    * *    *      *");}
		if(i== 3){ printf("  ** ***        * *   * *   *   *   ******* ");}
		if(i== 2){ printf("  *****         *  * *  *  *******  *       ");}
		if(i== 1){ printf("  ***           *   *   * *       * *       ");}
		printf("\n");
	}
	printf("  +------------------------------+");
	printf("  **     ");
	printf("\n");
	printf("    1 2 3 4 5 6 7 8 9101112131415");
	printf("  *******************************************");
	printf("\n");
}


void map_print2(void){
	int i,j;
	printf("*= ------------------------- virtual map system --------------------------- =*\n");
	printf("  +------------------------------+\n");
	for(i=15;i>=1;i--){
		for(j=1;j<=15;j++){
			if(j==1)printf("%2d|",i);
			if(num[j][i]<=10){
				printf("%2d",num[j][i]);
			}else{
				printf("  ");
			}
		}
		printf("|");
		if(i==15){ printf("      This virtual map presented by MIRS0701");}
		if(i==14){ printf("            made by Ozawa Taku & Ozawa Ryuji");}
		if(i==13){ printf(" =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i==12){ printf(" *Field : 3200 x 3200 *ONE BLOCK : 227 x 227");}
		if(i==11){ printf("            *MIRS: 3 *POST: 1X *POST NEAR: 0");}
		if(i==10){ printf("           *00: unknown post *X: Post number");}
		if(i== 9){ printf(" =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i== 8){ printf("  **                                        ");}
		if(i== 7){ printf("  **     ***********************************");}
		if(i== 6){ printf("  **    ***                                 ");}
		if(i== 5){ printf("  **   ***      *       *     *     ******* ");}
		if(i== 4){ printf("  **  ***       *      **    * *    *      *");}
		if(i== 3){ printf("  ** ***        * *   * *   *   *   ******* ");}
		if(i== 2){ printf("  *****         *  * *  *  *******  *       ");}
		if(i== 1){ printf("  ***           *   *   * *       * *       ");}
		printf("\n");
	}
	printf("  +------------------------------+");
	printf("  **     ");
	printf("\n");
	printf("    1 2 3 4 5 6 7 8 9101112131415");
	printf("  *******************************************");
	printf("\n");
}

void map_clean(void){
	int i,j;
	
	for(i=0;i<16;i++){
		for(j=0;j<16;j++){
			num[j][i]=0;
		}
	}
}

void map_set(void){
	FILE *fp2;
	int i,j,dis[5],ang[5];
	double sx,sy;
	
	fp2=fopen("txt/map_set.txt","w");

	for(i=0;i<5;i++){
		if(post_dis[i]!=0){
			ang[i] = post_ang[i]+POST_ANG_DIFF;
			dis[i] = post_dis[i]+USS_CORRECT+MMIRS_DIAMETER/2+MPOST_DIAMETER/2;
		}
	}
	fprintf(fp2,"%d,%d\n",ang[0],dis[0]);
	for(i=0;i<5;i++){
		if(post_dis[i]!=0){
			sx=(double)dis[i]*cos((ang[i])*PI/180)/ONE_B;	//debag 
			sy=(double)dis[i]*sin((ang[i])*PI/180)/ONE_B; //debug
//			fprintf(fp2,"%f,%f\n",sx[i],sy[i]);
			if(sx > 0){sx += 0.5;}
			if(sx < 0){sx -= 0.5;}
			if(sy > 0){sy += 0.5;}
			if(sy < 0){sy -= 0.5;}
			px[i] = (int)sx +m[1];
			py[i] = (int)sy +m[0];
			if(px[i]<16 && py[i]<16 && px[i]>0 && py[i]>0){
				fprintf(fp2,"i=%d px = %d,py = %d\n",i,px[i],py[i]);
				num[px[i]][py[i]] = 10;
			}
		}
	}
	for(i=1;i<16;i++){
		for(j=1;j<16;j++){
			if(num[j][i]>=10 && num[j][i]<20){
				num[j+1][i  ]=0;
				num[j+1][i+1]=0;
				num[j+1][i-1]=0;
				num[j  ][i+1]=0;
				num[j  ][i-1]=0;
				num[j-1][i  ]=0;
				num[j-1][i+1]=0;
				num[j-1][i-1]=0;				
			}
		}
	}
	fclose(fp2);
}

int map_absmove_ang(int x,int y){
	FILE *fp3;
	int re_ang;
	double dummy;
	int rel_x,rel_y;
	fp3=fopen("txt/map_ang.txt","w");
//	fprintf(fp3,"MIRS : X = %d Y = %d ang = %d\n",m[0],m[1],m[2]);
	fprintf(fp3,"MIRS : X = %d Y = %d ang = %d\n",m[1],m[0],m[2]);
	fprintf(fp3,"post_x = %d post_y = %d\n",x,y);
	rel_x = x - m[1];
	rel_y = y - m[0];
	fprintf(fp3,"RELATIVE : X = %d Y = %d\n",rel_x,rel_y);
	dummy=180/PI*atan2(rel_y,rel_x);
	if(dummy >   0)dummy+=0.5;
	if(dummy <   0)dummy-=0.5;
	re_ang=(int)dummy - m[2];
	fprintf(fp3,"map_absmove_ang    = %d\n",re_ang);
//	re_ang=Mangle(re_ang);
	fprintf(fp3,"Mangle = %d\n",re_ang);
	fclose(fp3);
	return re_ang;
}

int map_absmove_dis(int x,int y){
	FILE *fp4;
	int re_dis;
	double dummy;
	int rel_x,rel_y;
	fp4=fopen("txt/map_dis.txt","w");
	fprintf(fp4,"MIRS : X = %d Y = %d ang = %d\n",m[1],m[0],m[2]);
	fprintf(fp4,"post_x = %d post_y = %d\n",x,y);
	rel_x = x - m[1];
	rel_y = y - m[0];
	fprintf(fp4,"RELATIVE : X = %d Y = %d\n",rel_x,rel_y);
	dummy = ONE_B * sqrt(rel_x*rel_x+rel_y*rel_y);
	fprintf(fp4,"dis    = %f\n",dummy);
	if(dummy >   0)dummy+=0.5;
	if(dummy <   0)dummy-=0.5;	
	re_dis=(int)dummy - 400 -MMIRS_DIAMETER/2 -MPOST_DIAMETER/2;	
//	re_dis=(int)dummy - 400;	
	fprintf(fp4,"map_absmove_dis    = %d\n",re_dis);
	fclose(fp4);
	return re_dis;
}

int map_move(int x,int y,int z){
	FILE *fp5;
	int i,j,ang,dis,re=-1,flag=0,MX,MY,PX,PY,xx,yy;
	double X,Y;
	fp5=fopen("txt/map_move.txt","w");
//	MX = m[0]; MY = m[1];
	MX = m[1]; MY = m[0];
	PX = x;    PY = y;
	fprintf(fp5,"%f,%f\n",X,Y);
	for(i=1;i<8;i++){
		j=8-i;
		X = (double)(i*MX + j*PX)/8;
		Y = (double)(i*MY + j*PY)/8;
		xx = half_adjust(X);
		yy = half_adjust(Y);
//		if(num[xx][yy] == 0)flag=1;
		num[xx][yy] = i*11;
		fprintf(fp5,"X = %f Y = %f\n",X,Y);
		fprintf(fp5,"xx = %d yy = %d\n",xx,yy);
	}
	if(flag==1){x = 8; y = 8;}else{re=1;}
	ang = map_absmove_ang(x,y);
	m[2]+=ang;
//	ang = (int)((double)map_absmove_ang(x,y)*MIRS);
	dis = map_absmove_dis(x,y);
	fprintf(fp5,"rotate ang=%d \nstraight dis=%d\n",ang,dis);
	lqr_rotate(ang,ang*23);
	while(m[2]>360){m[2]-=360;}
	while(m[2]<0){m[2]+=360;}
	usleep(40000);
	/*test*/
	if(dis > 501){
		dis-=100;
	}
	if(z==0){
		dis += 400;
		m[1]=x;
		m[0]=y;

	}
	/*test end*/
	lqr_straight2(dis,dis*5);
	fclose(fp5);
	return re;	
}

void map_firstset(int found){
	int i,j,dis[5],ang[5],zerodat[5];
	double sx,sy;
	map_errorcheck();
	for(i=0;i<5;i++){
		zerodat[i] = 0;
	}
	
	for(i=0;i<5;i++){
		if(post_dis[i]!=0){
			ang[i] = post_ang[i]+POST_ANG_DIFF;
			dis[i] = post_dis[i]+USS_CORRECT+MCENTER_USS3_DIS+MPOST_DIAMETER/2;
		}
	}
	for(i=0;i<5;i++){
		if(post_dis[i]!=0){
			sx=(double)dis[i]*cos((ang[i])*PI/180)/ONE_B;	//debag 
			sy=(double)dis[i]*sin((ang[i])*PI/180)/ONE_B; //debug
			px[i] = half_adjust(sx) + m[1];
			py[i] = half_adjust(sy) + m[0];
			if(px[i]<16 && py[i]<16 && px[i]>0 && py[i]>0){
				printf("px = %d,py = %d\n",px[i],py[i]);
				if(num[px[i]][py[i]] == 10 || num[px[i]][py[i]] == 0){
					printf("get two posts data in one block!!\n");
					zerodat[i] = 1;
				}else{
					num[px[i]][py[i]] = 10;
					num[px[i]+1][py[i]  ]=0;
					num[px[i]+1][py[i]+1]=0;
					num[px[i]+1][py[i]-1]=0;
					num[px[i]  ][py[i]+1]=0;
					num[px[i]  ][py[i]-1]=0;
					num[px[i]-1][py[i]  ]=0;
					num[px[i]-1][py[i]+1]=0;
					num[px[i]-1][py[i]-1]=0;						
				}
			}
		}
	}
	
	for(i=0;i<=found;i++){
		if(zerodat[i+1] == 1){
				printf("ex post_ang[%d] = %d\n",i,post_ang[i]);
				printf("ex post_dis[%d] = %d\n",i,post_dis[i]);
				printf("\n");
				
			if(i+1<=found){
				post_dis[i+0] = half_adjust((double)((post_dis[i] + post_dis[i+1])/2));
				post_ang[i+0] = half_adjust((double)((post_ang[i] + post_ang[i+1])/2));
			}
			if(i+2<=found){
				post_dis[i+1] = post_dis[i+2];
				post_ang[i+1] = post_ang[i+2];
			}
			if(i+3<=found){
				post_dis[i+2] = post_dis[i+3];
				post_ang[i+2] = post_ang[i+3];
			}
			if(i+4<=found){
				post_dis[i+3] = post_dis[i+4];
				post_ang[i+0] = post_ang[i+4];
			}
		}
	}
	/*test*/
	for(i=0;i<=found;i++){
		if(post_dis[i] == 0){post_ang[i] = 0;}
		//printf("post_ang[%d] = %d\n",i,post_ang[i]);
		//printf("post_dis[%d] = %d\n",i,post_dis[i]);
		//printf("\n");
	}
}

void map_analyze(int n){
	int i,j,k,l,m,x;
	int num2[16][16];
	for(i=0;i<16;i++){
		for(j=0;j<16;j++){
		num2[i][j] = 0;
		}
	}

	
	for(l=0;l<=13+n;l++){
		for(i=0;i<=13+n;i++){
			m=0;
			for(j=2-n+l;j<=1+l;j++){
				for(k=2-n+i;k<=1+i;k++){
					if(j>= 1 && k >= 1 && j <= 15 && k <= 15){
						if(num[j][k] >= 10 && num[j][k] < 16){m++;}else{}
					}
				}
			}
			for(j=2-n+l;j<=1+l;j++){
				for(k=2-n+i;k<=1+i;k++){
					if(j>= 1 && k >= 1 && j <= 15 && k <= 15){
						//printf("m = %d\n",m);
						if(m!=0){num2[j][k]+=1;}
					}
				}
			}
		}
	}
	

	for(i=0;i<16;i++){
		for(j=0;j<16;j++){
		num[i][j] = num2[i][j];
		}
	}


	
}

void map_filter(void){
	int i,j;
	for(i=6;i<=10;i++){
		for(j=6;j<=10;j++){
			num[i][j] = 99;
		}
	}
	num[8 ][5 ] = 99;
	num[5 ][8 ] = 99;
	num[8 ][11] = 99;
	num[11][8 ] = 99;
	for(i=1;i<=15;i++){
		num[1][i] = 99;
		num[i][1] = 99;
		num[15][i] = 99;
		num[i][15] = 99;
	}


}


void map_theory(void){
	int i,j,first=0,second=0,third=0,forth=0;
	int flag=0,x=0,y=0,ang=0;
	for(i=9;i<16;i++){
		for(j=9;j<16;j++){
//			num[j][i] = 77;
			if(num[j][i] >= 10 && num[j][i] < 16)  first += 1;
		}
	}
	for(i=9;i<16;i++){
		for(j=1;j<8;j++){
//			num[j][i] = 66;
			if(num[j][i] >= 10 && num[j][i] <16)  second += 1;
		}
	}
	for(i=1;i<8;i++){
		for(j=1;j<8;j++){
//			num[j][i] = 55;
			if(num[j][i] >= 10 && num[j][i] <16)   third += 1;
		}
	}
	for(i=1;i<8;i++){
		for(j=9;j<16;j++){
//			num[j][i] = 44;
			if(num[j][i] >= 10 && num[j][i] <16)   forth += 1;
		}
	}
//	printf("first : %d\n",first );
//	printf("second: %d\n",second);
//	printf("third : %d\n",third );
//	printf("forth : %d\n",forth );
	if(first  == 0) flag +=    1;
	if(second == 0) flag +=   10;
	if(third  == 0) flag +=  100;
	if(forth  == 0) flag += 1000;

	printf("flag = %d\n",flag);

	if(flag >= 1000){
		x = 11;y =  5;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=315-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach3();
		/*theory_search();*/
		flag -= 1000;
//		map_move(8,8,0);
	}
	if(flag >=  100){
		x =  5;y =  5;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=225-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach3();
		/*theory_search();*/
		flag -=  100;
//		map_move(8,8,0);
	}
	if(flag >=   10){
		x =  5;y = 11;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=135-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach3();
		/*theory_search();*/
		flag -=   10;
//		map_move(8,8,0);
	}
	if(flag >=    1){
		x = 11;y = 11;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=45-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach3();
		/*theory_search();*/
		flag -=    1;
//		map_move(8,8,0);
	}
	
//	printf("flag = %d\n",flag);
//	printf("x = %d y = %d\n",x,y);

}

void map_theory2(void){
	int i,j,first=0,second=0,third=0,forth=0;
	int flag=0,x=0,y=0,ang=0;
	for(i=9;i<16;i++){
		for(j=9;j<16;j++){
//			num[j][i] = 77;
			if(num[j][i] >= 10 && num[j][i] < 16)  first += 1;
		}
	}
	for(i=9;i<16;i++){
		for(j=1;j<8;j++){
//			num[j][i] = 66;
			if(num[j][i] >= 10 && num[j][i] <16)  second += 1;
		}
	}
	for(i=1;i<8;i++){
		for(j=1;j<8;j++){
//			num[j][i] = 55;
			if(num[j][i] >= 10 && num[j][i] <16)   third += 1;
		}
	}
	for(i=1;i<8;i++){
		for(j=9;j<16;j++){
//			num[j][i] = 44;
			if(num[j][i] >= 10 && num[j][i] <16)   forth += 1;
		}
	}
//	printf("first : %d\n",first );
//	printf("second: %d\n",second);
//	printf("third : %d\n",third );
//	printf("forth : %d\n",forth );
	if(first  == 0) flag +=    1;
	if(second == 0) flag +=   10;
	if(third  == 0) flag +=  100;
	if(forth  == 0) flag += 1000;

	printf("flag = %d\n",flag);

	if(flag >= 1000){
		x = 11;y =  5;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=315-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach5();
		/*theory_search();*/
		flag -= 1000;
//		map_move(8,8,0);
	}
	if(flag >=  100){
		x =  5;y =  5;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=225-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach5();
		/*theory_search();*/
		flag -=  100;
//		map_move(8,8,0);
	}
	if(flag >=   10){
		x =  5;y = 11;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=135-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach5();
		/*theory_search();*/
		flag -=   10;
//		map_move(8,8,0);
	}
	if(flag >=    1){
		x = 11;y = 11;
		num[x][y] = 33;
		map_move(x,y,0);
		ang=45-m[2];		//added
		while(ang>180){ang-=360;}//added
		while(ang<-180){ang+=360;}//added 
		m[2]+=ang;		//added
		m[2]+=ang;		//added
		lqr_rotate(ang,ang*19);	//added
		post_approach5();
		/*theory_search();*/
		flag -=    1;
//		map_move(8,8,0);
	}
	
//	printf("flag = %d\n",flag);
//	printf("x = %d y = %d\n",x,y);

}


void map_fprint(int mode){
	FILE *mapfp;
	int i,j;
	switch(mode){
		case 0:
			mapfp = fopen("map/vmap_360_search.txt","w");
			break;
		case 1:
			mapfp = fopen("map/vmap_1st_approach.txt","w");
			break;
		case 2:
			mapfp = fopen("map/vmap_2nd_approach.txt","w");
			break;
		case 3:
			mapfp = fopen("map/vmap_3rd_approach.txt","w");
			break;
		case 4:
			mapfp = fopen("map/vmap_4th_approach.txt","w");
			break;
		case 5:
			mapfp = fopen("map/vmap_theory.txt","w");
			break;			
		case 6:
			mapfp = fopen("map/vmap_analyze.txt","w");
			break;
		case 7:
			mapfp = fopen("map/vmap_extra.txt","w");
			break;
		case 8:
			mapfp = fopen("map/vmap_test.txt","w");
			break;
	}
	fprintf(mapfp,"*= ------------------------- virtual map system --------------------------- =*\n");
	fprintf(mapfp,"  +------------------------------+\n");
	for(i=15;i>=1;i--){
		for(j=1;j<=15;j++){
			if(j==1)fprintf(mapfp,"%2d|",i);
			if(num[j][i]!=1){
				fprintf(mapfp,"%2d",num[j][i]);
			}else{
				fprintf(mapfp,"  ");
			}
		}
		fprintf(mapfp,"|");
		if(i==15){ fprintf(mapfp,"      This virtual map presented by MIRS0701");}
		if(i==14){ fprintf(mapfp,"            made by Ozawa Taku & Ozawa Ryuji");}
		if(i==13){ fprintf(mapfp," =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i==12){ fprintf(mapfp," *Field : 3200 x 3200 *ONE BLOCK : 227 x 227");}
		if(i==11){ fprintf(mapfp,"            *MIRS: 3 *POST: 1X *POST NEAR: 0");}
		if(i==10){ fprintf(mapfp,"           *00: unknown post *X: Post number");}
		if(i== 9){ fprintf(mapfp," =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=");}
		if(i== 8){ fprintf(mapfp,"  **                                        ");}
		if(i== 7){ fprintf(mapfp,"  **     ***********************************");}
		if(i== 6){ fprintf(mapfp,"  **    ***                                 ");}
		if(i== 5){ fprintf(mapfp,"  **   ***      *       *     *     ******* ");}
		if(i== 4){ fprintf(mapfp,"  **  ***       *      **    * *    *      *");}
		if(i== 3){ fprintf(mapfp,"  ** ***        * *   * *   *   *   ******* ");}
		if(i== 2){ fprintf(mapfp,"  *****         *  * *  *  *******  *       ");}
		if(i== 1){ fprintf(mapfp,"  ***           *   *   * *       * *       ");}
		fprintf(mapfp,"\n");
	}
	fprintf(mapfp,"  +------------------------------+");
	fprintf(mapfp,"  **     ");
	fprintf(mapfp,"\n");
	fprintf(mapfp,"    1 2 3 4 5 6 7 8 9101112131415");
	fprintf(mapfp,"  *******************************************");
	fprintf(mapfp,"\n");
	fprintf(mapfp,"mirs x=%d y=%d ang=%d \n",m[1],m[0],m[2]);
	fclose(mapfp);
	mapfp = fopen("txt/log.txt","w");
	for(i=0;i<=5;i++){
		fprintf(mapfp,"%d\t%d\t%d\n",post_code[i],px[i],py[i]);
	}
	fclose(mapfp);

	
}

void map_distance(int *p){
	FILE *fpm;
	int i,j,k=0,re,postx[6],posty[6],dis[6],m1,m2,correct=0;
	int first=0,second=0,third=0,forth=0;
	for(i=0;i<4;i++){
		postx[i]= 0;
		posty[i]= 0;
		dis[i]  = 0;
	}
	
	for(i=0;i<5;i++){
			postx[i] = px[i];
			posty[i] = py[i];
			if(px[i] != 0 && py[i] != 0){correct++;}
		printf("postx[%d] = %d\n",i,postx[i]);
		printf("posty[%d] = %d\n",i,posty[i]);
//		printf("0:postx[%d] = %d\n",0,postx[0]);
	}
	printf("correct = %d\n",correct);
	
//	printf("test:postx[%d] = %d\n",0,postx[0]);
	k=0;
	for(i=0;i<5;i++){
		if(postx[i] == 0 && posty[i] == 0){
//			printf("* post[%d][0] = %d\n",i,postx[i]);
//			printf("* post[%d][1] = %d\n",i,posty[i]);
			k = i-1;
			printf("k = %d\n",k);
			break;
		}
	}
//	printf("test:postx[%d] = %d\n",0,px[0]);
	for(i=0;i<k;i++){
//		printf("x1 = %d y1 = %d\nx2 = %d y2 = %d\n\n",postx[i],posty[i],postx[i+1],posty[i+1]);
		dis[i]=map_distance_calcurate(postx[i],posty[i],postx[i+1],posty[i+1]);
		if(i == k-1 && k > 1){
			dis[k]=map_distance_calcurate(postx[0],posty[0],postx[k],posty[k]);
		}
	}
	
	if(dis[0]>=dis[1] && dis[0]>=dis[2] && dis[0]>=dis[3])
		{if(k==0){m1=0; m2=1;}else{m1=0; m2=1;}}		// 0 => 1 : 0 => 1
	if(dis[1]>=dis[2] && dis[1]>=dis[3] && dis[1]>=dis[0])
		{if(k==1){m1=0; m2=1;}else{m1=1; m2=2;}}		// 1 => 2 : 1 => 0 
	if(dis[2]>=dis[3] && dis[2]>=dis[0] && dis[2]>=dis[1])
		{if(k==2){m1=0; m2=2;}else{m1=2; m2=3;}}		// 2 => 3 : 2 => 0
	if(dis[3]>=dis[0] && dis[3]>=dis[1] && dis[3]>=dis[2])
		{if(k==3){m1=0; m2=3;}else{m1=0; m2=3;}}		// 3 => 0 : 3 => 0
	printf("m1=%d\nm2=%d\n",m1+1,m2+1);
	
	for(i=0;i<4;i++){
//		printf("dis[%d] = %d\n",i,dis[i]);
	}
//	printf("postx[m1] = %d posty[m1] = %d\n",postx[m1],posty[m1]);
//	printf("postx[m2] = %d posty[m1] = %d\n",postx[m2],posty[m2]);
	dis[0] = map_distance_calcurate(8,8,postx[m1],posty[m1]);
	dis[1] = map_distance_calcurate(8,8,postx[m2],posty[m2]);
	printf("C to m1=%d\nC to m2=%d\n",dis[0],dis[1]);
	if(dis[0]<=dis[1] && correct == 4){first=m1; forth=m2;}else if(correct == 4){first=m2; forth=m1;}
	if(dis[0]<=dis[1] && correct == 3){first=m1; third=m2;}else if(correct == 3){first=m2; third=m1;}
	if(dis[0]<=dis[1] && correct == 2){first=m1;second=m2;}else if(correct == 2){first=m2;second=m1;}
//	printf("first  = %d\n",first +1);
//	printf("second = %d\n",second+1);
//	printf("third  = %d\n",third +1);
//	printf("forth  = %d\n",forth +1);
//	printf("\n");

	if(correct == 4){
		if(first == 0 && forth == 1){second = 3;third = 2;}
		if(first == 0 && forth == 3){second = 1;third = 2;}
		if(first == 1 && forth == 0){second = 2;third = 3;}
		if(first == 1 && forth == 2){second = 0;third = 3;}
		if(first == 2 && forth == 1){second = 3;third = 0;}
		if(first == 2 && forth == 3){second = 1;third = 0;}
		if(first == 3 && forth == 0){second = 2;third = 1;}
		if(first == 3 && forth == 2){second = 0;third = 1;}
	}


	if(correct == 3){
		     if(first == 0 && third == 1)second = 2;
		else if(first == 0 && third == 2)second = 1;
		else if(first == 1 && third == 0)second = 2;
		else if(first == 1 && third == 2)second = 0;
		else if(first == 2 && third == 0)second = 1;
		else if(first == 2 && third == 1)second = 0;
	}


	if(correct == 3){forth = 999;}
	if(correct == 2){third = 999;forth = 999;}
	
	if(first == 0 && second == 0 && third == 0 && forth == 0){
		first = 0; second =1; third =2; forth=3;
	}

	printf("first  = %d\n",first +1);
	printf("second = %d\n",second+1);
	printf("third  = %d\n",third +1);
	printf("forth  = %d\n",forth +1);
	*p = first ;++p;
	*p = second;++p;
	*p = third ;++p;
	*p = forth ;
	fpm = fopen("txt/map_distance.txt","w");
	
	fprintf(fpm,"First  = %d\n",first +1);
	fprintf(fpm,"Second = %d\n",second+1);
	fprintf(fpm,"Third  = %d\n",third +1);
	fprintf(fpm,"Forth  = %d\n",forth +1);

	fclose(fpm);
}

int  map_distance_calcurate(int x1,int y1,int x2,int y2){
	int i,j,re;
	int rel_x,rel_y;
	double dummy;
	rel_x = abs(x1-x2);
	rel_y = abs(y1-y2);
	dummy = ONE_B * sqrt(rel_x*rel_x+rel_y*rel_y);
	re=half_adjust(dummy);
//	printf("dis = %d\n",re);
	return re;
}

void map_errorcheck(void){
	int i,j,lpx[5],lpy[5];
	printf("Error check start\n");
	for(i=0;i<5;i++){
		lpx[i] = 0;
		lpy[i] = 0;
	}
	for(i=0;i<5;i++){
		if(px[i]<=0 || px[i]>=16 || py[i]<=0 || py[i]>=16 ){
			px[i]=0;
			py[i]=0;
			for(j=i;j<5;j++){
				px[j] = px[j+1];
				py[j] = py[j+1];
			}
		}
	}
	for(i=0;i<5;i++){	
		printf("px[%d] = %2d ",i,px[i]);
		printf("py[%d] = %2d\n",i,py[i]);
	}
	printf("Error check end\n");
}
